#include <avr/pgmspace.h>
#include <stdint.h>

#include "keylayouts.h"

const KEYCODE_TYPE PROGMEM keycodes_ascii[] = {
        ASCII_20, ASCII_21, ASCII_22, ASCII_23,
        ASCII_24, ASCII_25, ASCII_26, ASCII_27,
        ASCII_28, ASCII_29, ASCII_2A, ASCII_2B,
        ASCII_2C, ASCII_2D, ASCII_2E, ASCII_2F,
        ASCII_30, ASCII_31, ASCII_32, ASCII_33,
        ASCII_34, ASCII_35, ASCII_36, ASCII_37,
        ASCII_38, ASCII_39, ASCII_3A, ASCII_3B,
        ASCII_3C, ASCII_3D, ASCII_3E, ASCII_3F,
        ASCII_40, ASCII_41, ASCII_42, ASCII_43,
        ASCII_44, ASCII_45, ASCII_46, ASCII_47,
        ASCII_48, ASCII_49, ASCII_4A, ASCII_4B,
        ASCII_4C, ASCII_4D, ASCII_4E, ASCII_4F,
        ASCII_50, ASCII_51, ASCII_52, ASCII_53,
        ASCII_54, ASCII_55, ASCII_56, ASCII_57,
        ASCII_58, ASCII_59, ASCII_5A, ASCII_5B,
        ASCII_5C, ASCII_5D, ASCII_5E, ASCII_5F,
        ASCII_60, ASCII_61, ASCII_62, ASCII_63,
        ASCII_64, ASCII_65, ASCII_66, ASCII_67,
        ASCII_68, ASCII_69, ASCII_6A, ASCII_6B,
        ASCII_6C, ASCII_6D, ASCII_6E, ASCII_6F,
        ASCII_70, ASCII_71, ASCII_72, ASCII_73,
        ASCII_74, ASCII_75, ASCII_76, ASCII_77,
        ASCII_78, ASCII_79, ASCII_7A, ASCII_7B,
        ASCII_7C, ASCII_7D, ASCII_7E, ASCII_7F
};      

#ifdef ISO_8859_1_A0
const KEYCODE_TYPE PROGMEM keycodes_iso_8859_1[] = {
        ISO_8859_1_A0, ISO_8859_1_A1, ISO_8859_1_A2, ISO_8859_1_A3,
        ISO_8859_1_A4, ISO_8859_1_A5, ISO_8859_1_A6, ISO_8859_1_A7,
        ISO_8859_1_A8, ISO_8859_1_A9, ISO_8859_1_AA, ISO_8859_1_AB,
        ISO_8859_1_AC, ISO_8859_1_AD, ISO_8859_1_AE, ISO_8859_1_AF,
        ISO_8859_1_B0, ISO_8859_1_B1, ISO_8859_1_B2, ISO_8859_1_B3,
        ISO_8859_1_B4, ISO_8859_1_B5, ISO_8859_1_B6, ISO_8859_1_B7,
        ISO_8859_1_B8, ISO_8859_1_B9, ISO_8859_1_BA, ISO_8859_1_BB,
        ISO_8859_1_BC, ISO_8859_1_BD, ISO_8859_1_BE, ISO_8859_1_BF,
        ISO_8859_1_C0, ISO_8859_1_C1, ISO_8859_1_C2, ISO_8859_1_C3,
        ISO_8859_1_C4, ISO_8859_1_C5, ISO_8859_1_C6, ISO_8859_1_C7,
        ISO_8859_1_C8, ISO_8859_1_C9, ISO_8859_1_CA, ISO_8859_1_CB,
        ISO_8859_1_CC, ISO_8859_1_CD, ISO_8859_1_CE, ISO_8859_1_CF,
        ISO_8859_1_D0, ISO_8859_1_D1, ISO_8859_1_D2, ISO_8859_1_D3,
        ISO_8859_1_D4, ISO_8859_1_D5, ISO_8859_1_D6, ISO_8859_1_D7,
        ISO_8859_1_D8, ISO_8859_1_D9, ISO_8859_1_DA, ISO_8859_1_DB,
        ISO_8859_1_DC, ISO_8859_1_DD, ISO_8859_1_DE, ISO_8859_1_DF,
        ISO_8859_1_E0, ISO_8859_1_E1, ISO_8859_1_E2, ISO_8859_1_E3,
        ISO_8859_1_E4, ISO_8859_1_E5, ISO_8859_1_E6, ISO_8859_1_E7,
        ISO_8859_1_E8, ISO_8859_1_E9, ISO_8859_1_EA, ISO_8859_1_EB,
        ISO_8859_1_EC, ISO_8859_1_ED, ISO_8859_1_EE, ISO_8859_1_EF,
        ISO_8859_1_F0, ISO_8859_1_F1, ISO_8859_1_F2, ISO_8859_1_F3,
        ISO_8859_1_F4, ISO_8859_1_F5, ISO_8859_1_F6, ISO_8859_1_F7,
        ISO_8859_1_F8, ISO_8859_1_F9, ISO_8859_1_FA, ISO_8859_1_FB,
        ISO_8859_1_FC, ISO_8859_1_FD, ISO_8859_1_FE, ISO_8859_1_FF
};
#endif // ISO_8859_1_A0

